/**
 * Copyright Copyright 2010 Simon Andrews
 *
 *    This file is part of Difference Tracker.
 *
 *    Difference Tracker is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Difference Tracker is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Difference Tracker; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package uk.ac.bbsrc.babraham.DifferenceTracker;
import java.util.Arrays;



public class SimpleStats {

	public static double mean (Double [] values) {
		
		double mean = 0;
		int count = 0;
		for (int i=0;i<values.length;i++) {
			if (values[i] == null) continue;
			mean += values[i];
			count++;
		}
		
		mean /= count;
		
		return mean;	
	}
	
	public static double mean (Integer [] values) {
		
		double mean = 0;
		int count = 0;
		for (int i=0;i<values.length;i++) {
			if (values[i] == null) continue;
			mean += values[i];
			count++;
		}
		
		mean /= count;
		
		return mean;	
	}

	
	public static double mean (double [] values) {
		
		double mean = 0;
		for (int i=0;i<values.length;i++) {
			mean += values[i];
		}
		
		mean /= values.length;
		
		return mean;	
	}

	public static double mean (int [] values) {
		
		double mean = 0;
		for (int i=0;i<values.length;i++) {
			mean += values[i];
		}
		
		mean /= values.length;
		
		return mean;	
	}

	public static double median (double [] values) {
		
		Arrays.sort(values);
		
		if (values.length %2 == 0) {
			double median = values[values.length/2];
			median += values[(values.length+1)/2];
			median /=2;
			return median;
		}
		else {
			return values[values.length/2];
		}
	}

	public static double median (int [] values) {
		
		Arrays.sort(values);
		
		if (values.length %2 == 0) {
			double median = values[values.length/2];
			median += values[(values.length+1)/2];
			median /=2;
			return median;
		}
		else {
			return values[values.length/2];
		}
	}
	
	
	public static double median (Integer [] values) {
		
		Arrays.sort(values);

		if (values.length %2 == 0) {
			double median = values[values.length/2];
			median += values[(values.length+1)/2];
			median /=2;
			return median;
		}
		else {
			return values[values.length/2];
		}
	}
	
	public static double stdev (double [] values, double mean) {
		double stdev = 0;
		
		for (int i=0;i<values.length;i++) {
			stdev += Math.pow(values[i]-mean, 2);
		}
		
		stdev /= values.length;
		
		stdev = Math.sqrt(stdev);
		
		return stdev;
	}
	
	public static double stdev (int [] values, double mean) {
		double stdev = 0;
		
		for (int i=0;i<values.length;i++) {
			stdev += Math.pow(values[i]-mean, 2);
		}
		
		stdev /= values.length;
		
		stdev = Math.sqrt(stdev);
		
		return stdev;
	}
	
	public static double stdev (double [] values) {
		double mean = mean(values);
		return stdev(values,mean);
	}
	
	public static double stdev (int [] values) {
		double mean = mean(values);
		return stdev(values,mean);
	}
	
}
